#ifndef H_MQSIE_PARSER
#define H_MQSIE_PARSER

#include <BipCpi.h>
#include <BipCci.h>
#include <BipCni.h>

#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001 */
#include <BipSampPluginUtil.h>
#endif

#include "node_utils.h"

#ifndef FALSE
#define FALSE	0==1
#endif
#ifndef TRUE
#define TRUE	1==1
#endif


typedef struct _ParserContext
{
   CciElement  *rootElement;
   CciChar      NextParserClassName[255];   /* The name of the next parser in the chain */
   CciBool      ParserType;
   CciChar      iCurrentCharacter;           /* The current character */
   void        *iCurrentElement;             /* Current element */
   void        *iBuffer;                     /* Buffer pointer */
   int          iSize;                       /* Size of input buffer in bytes */
   int          iIndex;                      /* Current position in the buffer */
// char        *lastFieldName;
	CciChar		 Class[16];
} PARSER_CONTEXT_ST;


#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001 */
/* ---------------------------------------------------------------- */
/*                     Internal constants                           */
/*                                                                  */
/* The interface expects some CciChar strings to be passed. These   */
/* have to be constructed from char strings using the supplied      */
/* utilities. The char constants are defined here along with the    */
/* static CciChar variables which will contain these constants      */
/* converted into CciChar format.                                   */
/*                                                                  */
/* ---------------------------------------------------------------- */
#define CONST_MQSIE          "MQSIE"
CciChar * constMQSIE         = 0;

#define CONST_PARSER_FACTORY  "ComIbmMQSIEParserFactory"
CciChar * constParserFactory = 0;

#define CONST_NONE				"none"
CciChar *constNone				= 0;

#define CONST_DATATYPE			"DATATYPE"
CciChar *constDATATYPE			= 0;

#define CONST_CLASS				"CLASS"
CciChar *constCLASS				= 0;

#define CONST_CONTROLNUM		"CONTROLNUM"
CciChar *constCONTROLNUM		= 0;

#define CONST_MSGNAME			"MSGNAME"
CciChar *constMSGNAME			= 0;

#define CONST_MSGSEQNO			"MSGSEQNO"
CciChar *constMSGSEQNO			= 0;

#define CONST_RECLEN				"RECLEN"
CciChar *constRECLEN				= 0;

#define CONST_RECDLM				"RECDLM"
CciChar *constRECDLM				= 0;

#define CONST_RECFM				"RECFM"
CciChar *constRECFM				= 0;

#define CONST_SENDER				"SENDER"
CciChar *constSENDER				= 0;

#define CONST_SENDQUAL			"SENDQUAL"
CciChar *constSENDQUAL			= 0;

#define CONST_RECEIVER			"RECEIVER"
CciChar *constRECEIVER			= 0;

#define CONST_RECVQUAL			"RECVQUAL"
CciChar *constRECVQUAL			= 0;

#define CONST_FROM				"FROM"
CciChar *constFROM				= 0;

#define CONST_UNIQUEID			"UNIQUEID"
CciChar *constUNIQUEID			= 0;

#define CONST_DATE				"DATE"
CciChar *constDATE				= 0;

#define CONST_TIME				"TIME"
CciChar *constTIME				= 0;

/* ---------------------------------------------------------------- */
/*                     Internal constants                           */
/*                                                                  */
/* The following are the characters that are of interest to us      */
/* when parsing MQSIE                                               */
/*                                                                  */
/* ---------------------------------------------------------------- */
#define chOpen           '('
#define chClose          ')'
#define chSemiColon      ';'

#endif


typedef struct _KeywordType
{
   CciChar *Keyword;
   int      Type;
} KeywordType;


void *parseNextItem(CciParser *parser, CciContext *context, CciElement *element );

int   WhatType(const CciChar *str);
int   SetElementValue(CciElement *elt, CciChar *value, int valType);
int   WriteElementValue(NodeStringBuffer *buf, CciElement *elt);

/********************************************************************************************/
/* DEBUG */
#ifdef WIN32
#ifdef _DEBUG
   FILE *OST = NULL;

   #define DBGPRINTF(x)  {\
   OST = fopen("\\DebugMQSIEparser.txt","a+"); \
      if(OST) fprintf x; \
         fclose(OST); \
   }
#endif
#endif

#if defined (AIX) || defined (SUN) || defined(HPUX) || defined(LINUX)			/* 16/09/2001 */
#ifdef _DEBUG
   FILE *OST = NULL;

   #define DBGPRINTF(x)  {\
   OST = fopen("/tmp/DebugMQSIEparser.txt","a+"); \
      if(OST) fprintf x; \
         fclose(OST); \
   }
#endif
#endif
/* DEBUG */
/********************************************************************************************/

#endif
